import React from 'react';

class PACK extends React.Component{
   constructor(props){
     super(props) 
     this.renderD3Component = this.renderD3Component.bind(this)
   }
  
   renderD3Component(){
       const render = PackComponent(this.node,
                                    { sum: d=> d.sample,
                                      sort:(a, b) => b.sample - a.sample,
                                      key: d=> d.name
                                     },
                                   )
       render(this.props.data)
   }
  
   componentDidMount(){
        this.renderD3Component()
   }
  
   componentDidUpdate(){
        this.renderD3Component()
   }
   
   render(){
     return (<svg viewBox = '0 0 400 400' ref = { node => this.node = node }>
         			<text x = '0' y = '30'> Packed SVG</text>
            </svg>);   
   }
  
} 
export default PACK;

import { select,
         pack,
         hierarchy,
         nest,
         scaleSequential,
         interpolateMagma,
         scaleOrdinal,
         range
       } from 'd3'

const PackComponent = (selection,props) => {
  
  
       const render = (data) => {
         
            console.log(data)
           
            let dim = select(selection).attr('viewBox')
            
            dim = dim.split(' ').map(d=>+d).slice(2)
         
            const circle =    pack()
                  .size([dim[0] - 2, dim[1] - 2])
                  .padding(3)
            
            const metaData = hierarchy(data).sum(props.sum)
            														.sort(props.sort)
            
 
            const metaCircleData = circle(metaData)
            
          
            const names = metaCircleData.descendants()
              						 .map(d => d.data)
              					  .filter( d=> !d.children )
                          .map(props.key)
            
            const clip =scaleOrdinal().domain(names).range(range(names.length))
            
            
            const drawCircleData = nest().key(d => d.height).entries(metaCircleData.descendants())
            
            const table = drawCircleData.filter(x=> x.key== 0)[0]
            														.values
                                        .map(d => d.data)
                                        .map(d=> d.name)
            
            const id = scaleOrdinal().domain(table).range(range(table.length))
            
            const im_offset = scaleOrdinal().domain(table)
         
            drawComponent(drawCircleData,id)
       }
       
       const drawComponent = (data,id) => {
         
           const node = select(selection).selectAll("g")
                .data(data)
                .enter().append("g")
                .selectAll("g")
                .data(d => d.values)
                .enter().append("g")
                  .attr("transform", d => `translate(${d.x + 1},${d.y + 1})`)
            
           const color = scaleSequential([8, 0], interpolateMagma)
           
           
           node.append("circle")
                .attr("r", d => d.r)
                .attr("fill", d => color(d.height));
         
           const leaf = node.filter(d => !d.children);
         
          // leaf.select('circle[fill]').remove();
           leaf.append('defs')
               .append('clipPath')
               .attr('id',d => id(d.data.name))
               .append('circle')
                 .attr("r", d =>{ 
                 return d.r;
               })
         
         
           leaf.append('image')
               .attr('href',d=>d.data.link)
               .attr('height',d=>2*d.r)
               .attr('x',d=>{console.log(+d.data.offset);return -d.r +(+d.data.offset)})
               .attr('y',d=>-d.r)
               .attr('clip-path',d =>`url(#${id(d.data.name)})`)
          
       }
       
       return render;
}

